/*****************************************************************************
 *
 *  COPYRIGHTS:
 *             This module contains code made available by Magneto Software 
 *             on an AS IS basis.  Any one receiving the module is considered 
 *             to be licensed under Magneto Software copyrights to use the 
 *             Magneto-provided source code in any way he or she deems fit, 
 *             including copying it, compiling it, modifying it, and 
 *             redistributing it, with or without modifications.  
 *
 *             A user of the module should understand that Magneto Software 
 *             cannot provide technical support for the module and will not be
 *             responsible for any consequences of use of the program.
 *
 *             Any notices, including this one, are not to be removed
 *             from the module without the prior written consent of
 *             Magneto Software.
 *
 *****************************************************************************/
// SystemInfoDemoDlg.cpp : implementation file
//

#include "stdafx.h"
#include "SystemInfoDemo.h"
#include "SystemInfoDemoDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSystemInfoDemoDlg dialog

CSystemInfoDemoDlg::CSystemInfoDemoDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CSystemInfoDemoDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CSystemInfoDemoDlg)
	m_strResults = _T("");
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CSystemInfoDemoDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CSystemInfoDemoDlg)
	DDX_Control(pDX, IDC_BUTTON_START, m_btStart);
	DDX_Control(pDX, IDC_CHECK_TIMER, m_bTimerCheck);
	DDX_Control(pDX, IDC_QUERY_COMBO, m_cbQuery);
	DDX_Control(pDX, IDC_SKSYSTEMINFOCTRL1, m_hSystemInfoCtrl);
	DDX_Text(pDX, IDC_EDIT_RESULTS, m_strResults);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CSystemInfoDemoDlg, CDialog)
	//{{AFX_MSG_MAP(CSystemInfoDemoDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BUTTON_START, OnButtonStart)
	ON_WM_TIMER()
	ON_BN_CLICKED(IDC_CHECK_TIMER, OnCheckTimer)
	ON_WM_DESTROY()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSystemInfoDemoDlg message handlers

BOOL CSystemInfoDemoDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	CString strData;
	int nIndex;
	UINT nID;
	for (int nQueryIndex = SK_SYS_QUERY_MIN; nQueryIndex != SK_SYS_QUERY_MAX; nQueryIndex ++)
	{
		switch (nQueryIndex)
		{
			case SK_TCP_INFO:
				nID = IDS_STRING_TCP_INFO;
				break;
			case SK_TCP_CONNECT_TABLE_INFO:
				nID = IDS_STRING_TCP_CONNECT_TABLE_INFO;
				break;
			case SK_UDP_INFO:
				nID = IDS_STRING_UDP_INFO;
				break;
			case SK_UDP_CONNECT_TABLE_INFO:
				nID = IDS_STRING_UDP_CONNECT_TABLE_INFO;
				break;
			case SK_ICMP_INFO:
				nID = IDS_STRING_ICMP_INFO;
				break;
			case SK_IP_INFO:
				nID = IDS_STRING_IP_INFO;
				break;
			case SK_IP_ROUTING_TABLE_INFO:
				nID = IDS_STRING_IP_ROUTING_TABLE_INFO;
				break;
			case SK_IP_ADDRESS_TABLE_INFO:
				nID = IDS_STRING_IP_ADDRESS_TABLE_INFO;
				break;
			case SK_INTERFACES_TABLE_INFO:
				nID = IDS_STRING_INTERFACES_TABLE;
				break;
			case SK_ADDRESS_TRANSLATION_TABLE_INFO:
				nID = IDS_STRING_ADDRESS_TRANSLATION_TABLE_INFO;
				break;
			default:
				nID = 0;
				break;
		}
		if (nID == 0)
			continue;
		strData.LoadString(nID);
		nIndex = m_cbQuery.AddString(strData);
		m_cbQuery.SetItemData(nIndex, nQueryIndex);
	}
	// select TCP connect table
	m_cbQuery.SetCurSel(6);
	m_nTimer = 0;
	m_bTimerCheck.SetCheck(1);
	OnCheckTimer();
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CSystemInfoDemoDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CSystemInfoDemoDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CSystemInfoDemoDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CSystemInfoDemoDlg::OnButtonStart() 
{
	USES_CONVERSION;
	long lRowStartBound = 0;
	long lRowEndBound = 0;
	long lColumnStartBound = 0;
	long lColumnEndBound = 0;
	long lDimension[2];

	CComVariant hVar;
	hVar.Clear();

	int nIndex = m_cbQuery.GetCurSel();
	if (nIndex == CB_ERR)
		return;

	DWORD dwAction = m_cbQuery.GetItemData(nIndex);

	switch (dwAction)
	{
		case SK_TCP_INFO:
			if (m_hSystemInfoCtrl.GetTcpInfo(&hVar) != ERROR_SUCCESS)
				return;
			break;
		case SK_TCP_CONNECT_TABLE_INFO:
			if (m_hSystemInfoCtrl.GetTcpConnectTableInfo(&hVar) != ERROR_SUCCESS)
				return;
			break;
		case SK_UDP_INFO:
			if (m_hSystemInfoCtrl.GetUdpInfo(&hVar) != ERROR_SUCCESS)
				return;
			break;
		case SK_UDP_CONNECT_TABLE_INFO:
			if (m_hSystemInfoCtrl.GetUdpConnectTableInfo(&hVar) != ERROR_SUCCESS)
				return;
			break;
		case SK_ICMP_INFO:
			if (m_hSystemInfoCtrl.GetIcmpInfo(&hVar) != ERROR_SUCCESS)
				return;
			break;
		case SK_IP_INFO:
			if (m_hSystemInfoCtrl.GetIpInfo(&hVar) != ERROR_SUCCESS)
				return;
			break;
		case SK_IP_ADDRESS_TABLE_INFO:
			if (m_hSystemInfoCtrl.GetIpAddressTableInfo(&hVar) != ERROR_SUCCESS)
				return;
			break;
		case SK_IP_ROUTING_TABLE_INFO:
			if (m_hSystemInfoCtrl.GetIpRoutingTableInfo(&hVar) != ERROR_SUCCESS)
				return;
			break;
		case SK_INTERFACES_TABLE_INFO:
			if (m_hSystemInfoCtrl.GetInterfacesTableInfo(&hVar) != ERROR_SUCCESS)
				return;
			break;
		case SK_ADDRESS_TRANSLATION_TABLE_INFO:
			if (m_hSystemInfoCtrl.GetAddressTranslationTableInfo(&hVar) != ERROR_SUCCESS)
				return;
			break;
		default:
			ASSERT(FALSE);
			return;
	}

	SAFEARRAY* pSafeArray  = hVar.parray;
	HRESULT hr = SafeArrayGetLBound(pSafeArray, 1, &lRowStartBound);
	if (FAILED(hr))
	{
		SafeArrayDestroy(pSafeArray);
		hVar.vt = VT_EMPTY;
		return;
	}

	hr = SafeArrayGetUBound(pSafeArray, 1, &lRowEndBound);
	if (FAILED(hr))
	{
		SafeArrayDestroy(pSafeArray);
		hVar.vt = VT_EMPTY;
		return;
	}
	
	hr = SafeArrayGetLBound(pSafeArray, 2, &lColumnStartBound);
	if (FAILED(hr))
	{
		SafeArrayDestroy(pSafeArray);
		hVar.vt = VT_EMPTY;
		return;
	}

	hr = SafeArrayGetUBound(pSafeArray, 2, &lColumnEndBound);
	if (FAILED(hr))
	{
		SafeArrayDestroy(pSafeArray);
		hVar.vt = VT_EMPTY;
		return;
	}

	CComVariant varValue;
	m_strResults.Empty();
	UpdateData(FALSE);
	CString strFormat;
	for (long lRowIndex = lRowStartBound; lRowIndex <= lRowEndBound; lRowIndex ++)
	{
		//Extract the flavor information from the array
		for (long lColumnIndex = lColumnStartBound; 
				lColumnIndex <= lColumnEndBound; lColumnIndex ++)
		{
			lDimension[0] = lRowIndex;
			lDimension[1] = lColumnIndex;

			hr = SafeArrayGetElement(pSafeArray, lDimension, &varValue);

			if(hr != S_OK)
			{
				varValue.Clear();
				continue;
			}

			varValue.ChangeType(VT_BSTR);
			strFormat.Format(_T("%s\t"), W2A(varValue.bstrVal));
			m_strResults += strFormat;
			TRACE(strFormat);
			::SysFreeString(varValue.bstrVal);
			varValue.vt = VT_EMPTY;
		}
		strFormat = _T("\r\n");
		m_strResults += strFormat;
		TRACE(strFormat);
	}
	SafeArrayDestroy(pSafeArray);
	hVar.vt = VT_EMPTY;
	UpdateData(FALSE);
}


void CSystemInfoDemoDlg::OnTimer(UINT nIDEvent) 
{
	OnButtonStart();
}

void CSystemInfoDemoDlg::OnCheckTimer() 
{
	BOOL bUseTimer = m_bTimerCheck.GetCheck();
	m_btStart.EnableWindow(!bUseTimer);
	if (bUseTimer)
	{
		if (m_nTimer == 0)
			m_nTimer = SetTimer(10, 1000, NULL);
	}
	else
	{
		if (m_nTimer)
			KillTimer(m_nTimer);
		m_nTimer = 0;
	}
	
}


void CSystemInfoDemoDlg::OnDestroy() 
{
	if (m_nTimer)
		KillTimer(m_nTimer);
	m_nTimer = NULL;

	CDialog::OnDestroy();
		
}
